[@@@warning "-9-27"]
include Ctypes
let lift x = x
open Ctypes_static

let rec field : type t a. t typ -> string -> a typ -> (a, t) field =
  fun s fname ftype -> match s, fname with
  | View { ty; _ }, _ ->
    let { ftype; foffset; fname } = field ty fname ftype in
    { ftype; foffset; fname }
  | _ -> failwith ("Unexpected field "^ fname)

let rec seal : type a. a typ -> unit = function
  | Struct { tag; spec = Complete _; _ } ->
    raise (ModifyingSealedType tag)
  | Union { utag; uspec = Some _; _ } ->
    raise (ModifyingSealedType utag)
  | View { ty; _ } -> seal ty
  | _ ->
    raise (Unsupported "Sealing a non-structured type")

type 'a const = 'a
let constant (type t) name (t : t typ) : t = match t, name with
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_GE" ->
    5L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_GT" ->
    4L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_LE" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_LT" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_NE" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_COMPARISON_EQ" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_RSHIFT" ->
    11L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_LSHIFT" ->
    10L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_LOGICAL_OR" ->
    9L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_LOGICAL_AND" ->
    8L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_BITWISE_OR" ->
    7L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_BITWISE_XOR" ->
    6L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_BITWISE_AND" ->
    5L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_MODULO" ->
    4L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_DIVIDE" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_MULT" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_MINUS" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BINARY_OP_PLUS" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_UNARY_OP_ABS" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_UNARY_OP_LOGICAL_NEGATE" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_UNARY_OP_BITWISE_NEGATE" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_UNARY_OP_MINUS" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_GLOBAL_IMPORTED" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_GLOBAL_INTERNAL" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_GLOBAL_EXPORTED" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_FUNCTION_ALWAYS_INLINE" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_FUNCTION_IMPORTED" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_FUNCTION_INTERNAL" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_FUNCTION_EXPORTED" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_COMPLEX_LONG_DOUBLE" ->
    22L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_COMPLEX_DOUBLE" ->
    21L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_COMPLEX_FLOAT" ->
    20L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_FILE_PTR" ->
    19L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_SIZE_T" ->
    18L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_CONST_CHAR_PTR" ->
    17L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_LONG_DOUBLE" ->
    16L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_DOUBLE" ->
    15L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_FLOAT" ->
    14L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_UNSIGNED_LONG_LONG" ->
    13L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_LONG_LONG" ->
    12L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_UNSIGNED_LONG" ->
    11L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_LONG" ->
    10L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_UNSIGNED_INT" ->
    9L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_INT" ->
    8L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_UNSIGNED_SHORT" ->
    7L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_SHORT" ->
    6L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_UNSIGNED_CHAR" ->
    5L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_SIGNED_CHAR" ->
    4L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_CHAR" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_BOOL" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_VOID_PTR" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_TYPE_VOID" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_OUTPUT_KIND_EXECUTABLE" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_OUTPUT_KIND_DYNAMIC_LIBRARY" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_OUTPUT_KIND_OBJECT_FILE" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_OUTPUT_KIND_ASSEMBLER" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_KEEP_INTERMEDIATES" ->
    7L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_SELFCHECK_GC" ->
    6L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DUMP_EVERYTHING" ->
    5L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DUMP_SUMMARY" ->
    4L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DUMP_GENERATED_CODE" ->
    3L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DUMP_INITIAL_GIMPLE" ->
    2L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DUMP_INITIAL_TREE" ->
    1L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_BOOL_OPTION_DEBUGINFO" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_INT_OPTION_OPTIMIZATION_LEVEL" ->
    0L
  | Ctypes_static.Primitive Cstubs_internals.Int64_t, "GCC_JIT_STR_OPTION_PROGNAME" ->
    0L
  | _, s -> failwith ("unmatched constant: "^ s)

let enum (type a) name ?typedef ?unexpected (alist : (a * int64) list) =
  match name with
  | "gcc_jit_comparison" -> 
    Cstubs_internals.build_enum_type "gcc_jit_comparison" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_binary_op" -> 
    Cstubs_internals.build_enum_type "gcc_jit_binary_op" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_unary_op" -> 
    Cstubs_internals.build_enum_type "gcc_jit_unary_op" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_global_kind" -> 
    Cstubs_internals.build_enum_type "gcc_jit_global_kind" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_function_kind" -> 
    Cstubs_internals.build_enum_type "gcc_jit_function_kind" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_types" -> 
    Cstubs_internals.build_enum_type "gcc_jit_types" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_output_kind" -> 
    Cstubs_internals.build_enum_type "gcc_jit_output_kind" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_bool_option" -> 
    Cstubs_internals.build_enum_type "gcc_jit_bool_option" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_int_option" -> 
    Cstubs_internals.build_enum_type "gcc_jit_int_option" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | "gcc_jit_str_option" -> 
    Cstubs_internals.build_enum_type "gcc_jit_str_option" Ctypes_static.Uint32 ?typedef ?unexpected alist
  | s ->
    failwith ("unmatched enum: "^ s)
